<template>
  <q-page :style-fn="heightHandler">
    <slot :height="height" :offset="offset"/>
  </q-page>
</template>

<script lang="ts">
import {defineComponent, ref, toRefs} from 'vue'

export default defineComponent({
  props: {
    padding: {type: Boolean, default: false}
  },

  setup(props) {
    const {padding} = toRefs(props);
    const height = ref('100vh');
    const offset = ref(0);

    function heightHandler(value: number) {
      height.value = value ? `calc(100vh - ${value}px)` : '100vh';
      offset.value = value ?? 0;

      return {minHeight: height.value};
    }

    return {
      padding,
      height,
      offset,
      heightHandler
    }
  }
});
</script>
